.\"	$NetBSD: reboot.2,v 1.26 2008/11/06 16:23:56 tsutsui Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)reboot.2	8.1 (Berkeley) 6/4/93
.\"
.Dd September 4, 2009
.Dt REBOOT 2
.Os
.Sh NAME
.Nm reboot
.Nd reboot system or halt processor
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.In sys/reboot.h
.Ft int
.Fn reboot "int howto" "char *bootstr"
.Sh DESCRIPTION
.Fn reboot
reboots the system.
Only the super-user may reboot a machine on demand.
However, a reboot is invoked
automatically in the event of unrecoverable system failures.
.Pp
.Fa howto
is a mask of options; the system call interface allows the following
options, defined in the include file
.Aq Pa sys/reboot.h ,
to be passed
to the new kernel or the new bootstrap and init programs.
In addition to the options described below, other options
described in
.Xr boothowto 9
may be set, but such options may be ignored by the system.
.Pp
Options can be combined together by OR'ing them, eg.
.Dv RB_DUMP |
.Dv RB_NOSYNC
would be interpreted as
.Dq dump kernel memory before rebooting and don't sync the disks .
.Bl -column RB_INITNAMEA 0x0000
.It Dv RB_AUTOBOOT Ta Li 0x0000 Ta
The default, causing the system to reboot in its usual fashion.
.It Dv RB_ASKNAME Ta Li 0x0001 Ta
Interpreted by the bootstrap program itself, causing it to
prompt on the console as to what file should be booted.
Normally, the system is booted from the file
.Dq Em xx Ns No (0,0)netbsd ,
where
.Em xx
is the default disk name,
without prompting for the file name.
.\" Obsolete!
.\" .It Dv RB_DFLTROOT Ta Li 0x0020 Ta
.\" Use the compiled in root device.
.\" Normally, the system uses the device from which it was booted
.\" as the root device if possible.
.\" (The default behavior is dependent on the ability of the bootstrap program
.\" to determine the drive from which it was loaded, which is not possible
.\" on all systems.)
.It Dv RB_DUMP Ta Li 0x0100 Ta
Dump kernel memory before rebooting; see
.Xr savecore 8
for more information.
.It Dv RB_HALT Ta Li 0x0008 Ta
the processor is simply halted; no reboot takes place.
This option should be used with caution.
.It Dv RB_POWERDOWN Ta Li 0x0808 Ta
This option is always used in conjunction with
.Dv RB_HALT ,
and if the system hardware supports the function, the system will be
powered off, otherwise it has no effect.
.It Dv RB_INITNAME Ta Li 0x0010 Ta
An option allowing the specification of an init program (see
.Xr init 8 )
other than
.Pa /sbin/init
to be run when the system reboots.
This switch is not currently available.
.It Dv RB_KDB Ta Li 0x0040 Ta
Load the symbol table and enable a built-in debugger in the system.
This option will have no useful function if the kernel is not configured
for debugging.
Several other options have different meaning if combined
with this option, although their use may not be possible
via the
.Fn reboot
call.
See
.Xr ddb 4
for more information.
.It Dv RB_NOSYNC Ta Li 0x0004 Ta
Normally, the disks are sync'd (see
.Xr sync 8 )
before the processor is halted or rebooted.
This option may be useful if file system changes have been made manually
or if the processor is on fire.
.It Dv RB_RDONLY Ta Li 0x0080 Ta
Initially mount the root file system read-only.
This is currently the default, and this option has been deprecated.
.It Dv RB_SINGLE Ta Li 0x0002 Ta
Normally, the reboot procedure involves an automatic disk consistency
check and then multi-user operations.
.Dv RB_SINGLE
prevents this, booting the system with a single-user shell
on the console.
.Dv RB_SINGLE
is actually interpreted by the
.Xr init 8
program in the newly booted system.
.Pp
When no options are given (i.e.,
.Dv RB_AUTOBOOT
is used), the system is
rebooted from file ``netbsd'' in the root file system of unit 0
of a disk chosen in a processor specific way.
An automatic consistency check of the disks is normally performed
(see
.Xr fsck 8 ) .
.It Dv RB_STRING Ta Li 0x0400 Ta
.Fa bootstr
is a string passed to the firmware on the machine, if possible, if this
option is set.
Currently this is only implemented on the sparc and the sun3 ports.
.It Dv RB_USERCONF Ta Li 0x1000 Ta
Initially invoke the
.Xr userconf 4
facility when the system starts up again, if it has been compiled into
the kernel that is loaded.
.El
.Sh RETURN VALUES
If successful, this call never returns.
Otherwise, a \-1 is returned and an error is returned in the global
variable
.Va errno .
.Sh ERRORS
.Bl -tag -width Er
.It Bq Er EPERM
The caller is not the super-user.
.El
.Sh SEE ALSO
.Xr ddb 4 ,
.\" .Xr crash 8 ,
.Xr halt 8 ,
.Xr init 8 ,
.Xr reboot 8 ,
.Xr savecore 8 ,
.Xr boothowto 9
.Sh HISTORY
The
.Fn reboot
function call appeared in
.Bx 4.0 .
.Pp
The
.Dv RB_DFLTROOT
option is now
.Em obsolete .
